/**
 * Generated by Apache Royale Compiler from org\apache\royale\svg\ClipBead.as
 * org.apache.royale.svg.ClipBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.svg.ClipBead');

goog.require('org.apache.royale.core.IRenderedObject');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.graphics.PathBuilder');
goog.require('org.apache.royale.utils.UIDUtil');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.svg.ClipBead = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.svg.ClipBead', org.apache.royale.svg.ClipBead);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.svg.ClipBead.prototype._strand;


/**
 * @private
 * @type {org.apache.royale.graphics.PathBuilder}
 */
org.apache.royale.svg.ClipBead.prototype._path;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.svg.ClipBead.prototype.document;


/**
 * @royaleignorecoercion Element
 * @royaleignorecoercion Object
 * @private
 */
org.apache.royale.svg.ClipBead.prototype.clip = function() {
  if (!this.path || !this.host) {
    return;
  }
  var /** @type {Node} */ svgElement = this.host.element;
  var /** @type {Element} */ defs = this.getChildNode(svgElement, "defs");
  var /** @type {Element} */ clipPath = this.getChildNode(defs, "clipPath");
  clipPath.id = "myClip" + org.apache.royale.utils.UIDUtil.createUID();
  if (clipPath.hasChildNodes()) {
    var /** @type {Object} */ childNodes = clipPath.childNodes;
    for (var /** @type {number} */ i = 0; i < childNodes.length; i++) {
      clipPath.removeChild(childNodes[i]);
    }
  }
  var /** @type {Element} */ pathNode = this.createChildNode(clipPath, "path");
  pathNode.setAttribute("d", this.path.getPathString());
  this.host.element.style["clipPath"] = "url(#" + clipPath.id + ")";
};


/**
 * @private
 * @param {Node} node
 * @param {string} tagName
 * @return {Node}
 */
org.apache.royale.svg.ClipBead.prototype.getChildNode = function(node, tagName) {
  if (!node.hasChildNodes()) {
    return this.createChildNode(node, tagName);
  }
  var /** @type {Object} */ childNodes = node.childNodes;
  for (var /** @type {number} */ i = 0; i < childNodes.length; i++) {
    if (childNodes[i].tagName == tagName) {
      return childNodes[i];
    }
  }
  return this.createChildNode(node, tagName);
};


/**
 * @private
 * @param {Node} parent
 * @param {string} tagName
 * @return {Node}
 */
org.apache.royale.svg.ClipBead.prototype.createChildNode = function(parent, tagName) {
  var /** @type {string} */ svgNs = "http://www.w3.org/2000/svg";
  var /** @type {Node} */ element = window.document.createElementNS(svgNs, tagName);
  parent.appendChild(element);
  return element;
};


org.apache.royale.svg.ClipBead.prototype.get__path = function() {
  return this._path;
};


org.apache.royale.svg.ClipBead.prototype.set__path = function(value) {
  this._path = value;
  this.clip();
};


org.apache.royale.svg.ClipBead.prototype.set__strand = function(value) {
  this._strand = value;
  if (this.path) {
    this.clip();
  }
};


org.apache.royale.svg.ClipBead.prototype.get__host = function() {
  return org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IRenderedObject);
};


Object.defineProperties(org.apache.royale.svg.ClipBead.prototype, /** @lends {org.apache.royale.svg.ClipBead.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.graphics.PathBuilder} */
path: {
get: org.apache.royale.svg.ClipBead.prototype.get__path,
set: org.apache.royale.svg.ClipBead.prototype.set__path},
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.svg.ClipBead.prototype.set__strand},
/**
  * @export
  * @type {org.apache.royale.core.IRenderedObject} */
host: {
get: org.apache.royale.svg.ClipBead.prototype.get__host}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.svg.ClipBead.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ClipBead', qName: 'org.apache.royale.svg.ClipBead', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.svg.ClipBead.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'path': { type: 'org.apache.royale.graphics.PathBuilder', access: 'readwrite', declaredBy: 'org.apache.royale.svg.ClipBead'},
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.svg.ClipBead'},
        'host': { type: 'org.apache.royale.core.IRenderedObject', access: 'readonly', declaredBy: 'org.apache.royale.svg.ClipBead'}
      };
    },
    methods: function () {
      return {
        'ClipBead': { type: '', declaredBy: 'org.apache.royale.svg.ClipBead'}
      };
    }
  };
};