/**
 * Generated by Apache Royale Compiler from org\apache\royale\svg\MaskBead.as
 * org.apache.royale.svg.MaskBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.svg.MaskBead');

goog.require('org.apache.royale.core.IRenderedObject');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.core.ITransformHost');
goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.core.WrappedHTMLElement');
goog.require('org.apache.royale.utils.UIDUtil');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.svg.MaskBead = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.svg.MaskBead', org.apache.royale.svg.MaskBead);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.svg.MaskBead.prototype._strand;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.svg.MaskBead.prototype.document;


/**
 * @private
 * @type {string}
 */
org.apache.royale.svg.MaskBead.prototype.maskElementId;


/**
 * @private
 * @param {Node} parent
 * @param {string} tagName
 * @return {Node}
 */
org.apache.royale.svg.MaskBead.prototype.createChildNode = function(parent, tagName) {
  var /** @type {string} */ svgNs = "http://www.w3.org/2000/svg";
  var /** @type {Node} */ element = window.document.createElementNS(svgNs, tagName);
  parent.appendChild(element);
  return element;
};


/**
 * @export
 * @param {org.apache.royale.core.ITransformHost} transformHost
 */
org.apache.royale.svg.MaskBead.prototype.unmaskElement = function(transformHost) {
  transformHost.transformElement.setAttribute("mask", "");
};


/**
 * @export
 * @param {org.apache.royale.core.ITransformHost} transformHost
 */
org.apache.royale.svg.MaskBead.prototype.maskElement = function(transformHost) {
  transformHost.transformElement.setAttribute("mask", "url(#" + this.maskElementId + ")");
};


org.apache.royale.svg.MaskBead.prototype.set__strand = function(value) {
  this._strand = value;
  var /** @type {Element} */ currentPositioner = org.apache.royale.utils.Language.as(value, org.apache.royale.core.IRenderedObject).element;
  var /** @type {Element} */ newPositioner = this.createChildNode(currentPositioner, "defs");
  newPositioner = this.createChildNode(newPositioner, "mask");
  this.maskElementId = newPositioner.id = "myMask" + org.apache.royale.utils.UIDUtil.createUID();
  org.apache.royale.utils.Language.as(value, org.apache.royale.core.IUIBase).positioner = newPositioner;
  newPositioner.setAttribute('style', currentPositioner.getAttribute('style'));
  var /** @type {Object} */ childNodes = currentPositioner.childNodes;
  for (var /** @type {number} */ i = 0; i < childNodes.length; i++) {
    var /** @type {Element} */ childNode = childNodes[i];
    if (childNode.tagName != "defs") {
      newPositioner.appendChild(childNode);
    }
  }
};


org.apache.royale.svg.MaskBead.prototype.get__host = function() {
  return org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IRenderedObject);
};


Object.defineProperties(org.apache.royale.svg.MaskBead.prototype, /** @lends {org.apache.royale.svg.MaskBead.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.svg.MaskBead.prototype.set__strand},
/**
  * @export
  * @type {org.apache.royale.core.IRenderedObject} */
host: {
get: org.apache.royale.svg.MaskBead.prototype.get__host}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.svg.MaskBead.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'MaskBead', qName: 'org.apache.royale.svg.MaskBead', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.svg.MaskBead.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.svg.MaskBead'},
        'host': { type: 'org.apache.royale.core.IRenderedObject', access: 'readonly', declaredBy: 'org.apache.royale.svg.MaskBead'}
      };
    },
    methods: function () {
      return {
        'MaskBead': { type: '', declaredBy: 'org.apache.royale.svg.MaskBead'},
        'unmaskElement': { type: 'void', declaredBy: 'org.apache.royale.svg.MaskBead', parameters: function () { return [  { index: 1, type: 'org.apache.royale.core.ITransformHost', optional: false } ]; }},
        'maskElement': { type: 'void', declaredBy: 'org.apache.royale.svg.MaskBead', parameters: function () { return [  { index: 1, type: 'org.apache.royale.core.ITransformHost', optional: false } ]; }}
      };
    }
  };
};